/* 
Тестировалось на Arduino IDE 1.8.5
Дата тестирования 21.06.2019г.
*/ 

#include <SoftwareSerial.h>
#include  <Wire.h>                                         // Подключаем библиотеку Wire
#include  <Adafruit_Sensor.h>                             // Подключаем библиотеку Adafruit_Sensor
#include  <Adafruit_BME280.h>                             // Подключаем библиотеку Adafruit_BME280

SoftwareSerial mySerial(3, 2);                           // Выводы SIM800L Tx & Rx подключены к выводам Arduino 3 и 2
#define SEALEVELPRESSURE_HPA (1013.25)                   // Задаем высоту
Adafruit_BME280 bme;

char incomingByte; 
String inputString;

float t;
float p;
float h;

void setup() 
{
  Serial.begin(9600);                   
  mySerial.begin(9600); 

  bme.begin(0x76);


  while(!mySerial.available()){             // Зацикливаем и ждем инициализацию SIM800L
   mySerial.println("AT");                  // Отправка команды AT
   delay(1000);                             // Пауза
   Serial.println("Connecting...");         // Печатаем текст
   }
   Serial.println("Connected!");            // Печатаем текст
   mySerial.println("AT+CMGF=1");           // Отправка команды AT+CMGF=1
   delay(1000);                             // Пауза
   mySerial.println("AT+CNMI=1,2,0,0,0");   // Отправка команды AT+CNMI=1,2,0,0,0
   delay(1000);                             // Пауза
   mySerial.println("AT+CMGL=\"REC UNREAD\"");
}

void loop()

{  
  if(mySerial.available()){                       // Проверяем, если есть доступные данные
      delay(100);                                 // Пауза
      
      while(mySerial.available()){                // Проверяем, есть ли еще данные.
      incomingByte = mySerial.read();             // Считываем байт и записываем в переменную incomingByte
      inputString += incomingByte;                // Записываем считанный  байт в массив inputString
      }
   
      delay(10);                                  // Пауза      
      Serial.println(inputString);                // Отправка в "Мониторинг порта" считанные данные
      inputString.toUpperCase();                  // Меняем все буквы на заглавные

      if (inputString.indexOf("DATA") > -1){      // Проверяем полученные данные
        t = bme.readTemperature();
        h = bme.readHumidity(); 
        p = (bme.readPressure() / 100.0F);
        sms(String("Temperature: " + String(t) + " *C " + " Humidity: " + String(h) + " % " + " Pressure: " + String(p) + " hPa"), String("+7xxxxxxxxxx")); // Отправка SMS  
        }     
        
        delay(50);
      if (inputString.indexOf("OK") == -1){
          mySerial.println("AT+CMGDA=\"DEL ALL\"");
          delay(1000);}
    
          inputString = "";}}

void sms(String text, String phone)  // Процедура Отправка SMS
{
  Serial.println("SMS send started");
  mySerial.println("AT+CMGS=\"" + phone + "\"");
  delay(500);
  mySerial.print(text);
  delay(500);
  mySerial.print((char)26);
  delay(500);
  Serial.println("SMS send complete");
  delay(2000);
}
